//+------------------------------------------------------------------+
//|                                            Murrey_Math_MT_VG.mq4 |
//|                       Copyright © 2004, Vladislav Goshkov (VG).  |
//|                                           4vg@mail.ru            |
//#property copyright "Vladislav Goshkov (VG)."
//#property link      "4vg@mail.ru"
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                               Copyright © 2020, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |
//|                                           mario.jemic@gmail.com  |
//|                          https://AppliedMachineLearning.systems  |
//+------------------------------------------------------------------+
//|                                 Support our efforts by donating  |
//|                                  Paypal : https://goo.gl/9Rj74e  |
//|                                 Patreon : https://goo.gl/GdXWeN  |
//+------------------------------------------------------------------+
// https://forex-station.com/viewtopic.php?p=1295414279#p1295414279
// modified by banzai
// July 7th, 2020
// not for sale, rent, auction, nor lease

#property copyright ""
#property link      ""
#property indicator_chart_window
//+------------------------------------------------------------------+
//| Define the Variables to use.....                                 |
//+------------------------------------------------------------------+
#property indicator_buffers 5
//+------------------------------------------------------------------------------------------------------------------+
   extern bool showChannel=true,showARROW=false; extern int MaxBars=1800;
    extern int SignalGap=4,dist=27; double b1[],b2[],b3[],b4[],trend[];
  extern color ToplineClr=C'34,34,34',BotlineClr=C'34,34,34',UpArrClr=clrDimGray,DnArrClr=clrDimGray;
    extern int lineWidth=4,ArrWidth=6,ArrCode=108; int Type;//C'255,100,44'
//+------------------------------------------------------------------------------------------------------------------+
   extern bool alertsOn=false,alertsOnCurrent=true,alertsmsg=false,alertsSound=false,alertsNotify=false;
           int timeframe,whichBar;
//+------------------------------------------------------------------------------------------------------------------+

//template code start1
extern string             button_note1          = "------------------------------";
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; // chart btn_corner for anchoring
extern string             btn_text              = "Channel";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                             //btn__font size
extern color              btn_text_color        = clrWhite;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 20;                                     //btn__x
extern int                button_y              = 13;                                     //btn__y
extern int                btn_Width             = 60;                                 //btn__width
extern int                btn_Height            = 20;                                //btn__height
extern string             button_note2          = "------------------------------";
bool                      show_data             = true;
string IndicatorName, IndicatorObjPrefix;
int WorkTime=0,Periods=0;
//template code end1

double HiPrice, LoPrice, Range;
datetime StartTime;
//+------------------------------------------------------------------+
//template code start2
string GenerateIndicatorName(const string target)
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//+------------------------------------------------------------------+
class VisibilityCotroller
{
   string buttonId;
   string visibilityId;
   bool show_data;
   bool recalc;
public:
   void Init(string id, string indicatorName, string caption, int x, int y)
   {
      recalc = false;
      visibilityId = indicatorName + "_visibility";
      double val;
      if (GlobalVariableGet(visibilityId, val))
         show_data = val != 0;
         
      buttonId = id;
      ChartSetInteger(0, CHART_EVENT_MOUSE_MOVE, 1);
      createButton(buttonId, caption, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_color);
      ObjectSetInteger(0,buttonId,OBJPROP_YDISTANCE, button_y);
      ObjectSetInteger(0,buttonId,OBJPROP_XDISTANCE, button_x);
   }
//+------------------------------------------------------------------+
   void DeInit()
   {
      ObjectDelete(ChartID(), buttonId);
   }
//+------------------------------------------------------------------+
   bool HandleButtonClicks()
   {
      if (ObjectGetInteger(0, buttonId, OBJPROP_STATE))
      {
         ObjectSetInteger(0, buttonId, OBJPROP_STATE, false);
         show_data = !show_data;
         GlobalVariableSet(visibilityId, show_data ? 1.0 : 0.0);
         recalc = true;
         return true;
      }
      return false;
   }
//+------------------------------------------------------------------+
   bool IsRecalcNeeded()
   {
      return recalc;
   }
//+------------------------------------------------------------------+
   void ResetRecalc()
   {
      recalc = false;
   }
//+------------------------------------------------------------------+
   bool IsVisible()
   {
      return show_data;
   }
//+------------------------------------------------------------------+
private:
   void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
   {
      ObjectDelete    (0,buttonID);
      ObjectCreate    (0,buttonID,OBJ_BUTTON,0,0,0);
      ObjectSetInteger(0,buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_TYPE,BORDER_RAISED);
      ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (0,buttonID,OBJPROP_FONT,font);
      ObjectSetString (0,buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(0,buttonID,OBJPROP_HIDDEN,1);
   }
};
VisibilityCotroller visibility;
//+------------------------------------------------------------------+
int init()
  {
   IndicatorName = GenerateIndicatorName("Channel");
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   visibility.Init("show_hide_Channel", IndicatorName, btn_text, button_x, button_y);

   int Buf=-1; IndicatorBuffers(5);
   if(Period()==PERIOD_MN1){showChannel=false;}
   if(Period()==PERIOD_M1) {dist=27*30.;}
   if(Period()==PERIOD_M2) {dist=27*15.;}
   if(Period()==PERIOD_M3) {dist=27*10.;}
   if(Period()==PERIOD_M5) {dist=27*6.;}
   if(Period()==PERIOD_M15){dist=27*2.;} 
   if(Period()==PERIOD_M30){dist=27*1.;}
   if(Period()>=PERIOD_H1) {dist=14*1.;}
   if(showChannel)  Type=DRAW_LINE; else Type=DRAW_NONE;
   Buf+=1; SetIndexBuffer(Buf,b1); SetIndexStyle(Buf,Type, EMPTY,lineWidth,ToplineClr);
   Buf+=1; SetIndexBuffer(Buf,b2); SetIndexStyle(Buf,Type, EMPTY,lineWidth,BotlineClr);
   if(showARROW)    Type=DRAW_ARROW; else Type=DRAW_NONE;
   Buf+=1; SetIndexBuffer(Buf,b3); SetIndexStyle(Buf,Type,0,ArrWidth,UpArrClr); SetIndexArrow(Buf,ArrCode);
   Buf+=1; SetIndexBuffer(Buf,b4); SetIndexStyle(Buf,Type,0,ArrWidth,DnArrClr); SetIndexArrow(Buf,ArrCode); 
   Buf+=1; SetIndexBuffer(Buf,trend); SetIndexStyle(Buf,DRAW_NONE); 

   return 0;
};
//+------------------------------------------------------------------+
int deinit()  
  {
   visibility.DeInit();
    ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);
   return(0);
  }
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   if (visibility.HandleButtonClicks())
      start();
}
//+------------------------------------------------------------------+
//template end2
int start()
{
//template start3
   visibility.HandleButtonClicks();
   visibility.ResetRecalc();
   
   if (visibility.IsVisible())
   {
//template end3

   int i,hhb,llb; if(MaxBars>=Bars) MaxBars=Bars;
   for (i=0;i<MaxBars;i++) {b1[i]=0; b2[i]=0; b3[i]=0; b4[i]=0;
   hhb=iHighest(Symbol(),0,MODE_HIGH,dist,i-dist/2);
   llb= iLowest(Symbol(),0,MODE_LOW, dist,i-dist/2); 
   if(i==hhb) {b3[i]=High[hhb]+SignalGap*Point; trend[i]= 1;}
   if(i==llb) {b4[i]= Low[llb]-SignalGap*Point; trend[i]=-1;}
   b1[i]=High[hhb]; b2[i]=Low[llb];} manageAlerts(); 

//template start4
      if( (WorkTime != Time[0]) || (Periods != Period()) ) 
      {
         if (show_data)
         {
   if(showChannel)  Type=DRAW_LINE; else Type=DRAW_NONE;
   SetIndexStyle(0,Type, EMPTY,lineWidth,ToplineClr);
   SetIndexStyle(1,Type, EMPTY,lineWidth,BotlineClr);
   if(showARROW)    Type=DRAW_ARROW; else Type=DRAW_NONE;
   SetIndexStyle(2,Type,0,ArrWidth,UpArrClr); SetIndexArrow(2,ArrCode);
   SetIndexStyle(3,Type,0,ArrWidth,DnArrClr); SetIndexArrow(3,ArrCode); 
   SetIndexStyle(4,DRAW_NONE); 
         }
         else
         {
   if(showChannel)  Type=DRAW_LINE; else Type=DRAW_NONE;
   SetIndexStyle(0,Type, EMPTY,lineWidth,clrNONE);
   SetIndexStyle(1,Type, EMPTY,lineWidth,clrNONE);
   if(showARROW)    Type=DRAW_ARROW; else Type=DRAW_NONE;
   SetIndexStyle(2,Type,0,ArrWidth,clrNONE); 
   SetIndexStyle(3,Type,0,ArrWidth,clrNONE);  
   SetIndexStyle(4,DRAW_NONE); 
         }
      }
   }
   else
   {
   if(showChannel)  Type=DRAW_LINE; else Type=DRAW_NONE;
   SetIndexStyle(0,Type, EMPTY,lineWidth,clrNONE);
   SetIndexStyle(1,Type, EMPTY,lineWidth,clrNONE);
   if(showARROW)    Type=DRAW_ARROW; else Type=DRAW_NONE;
   SetIndexStyle(2,Type,0,ArrWidth,clrNONE); 
   SetIndexStyle(3,Type,0,ArrWidth,clrNONE);  
   SetIndexStyle(4,DRAW_NONE); 
   }
//template end4  
   return(0);
}
//+------------------------------------------------------------------+
   void manageAlerts() {if(alertsOn) {if(alertsOnCurrent) whichBar=0; else whichBar=1; 
   whichBar=iBarShift(NULL,0,iTime(NULL,0,whichBar));
   if(trend[whichBar]!=trend[whichBar+1]) {if(trend[whichBar]==0) doAlert(whichBar,"WAIT");
   if(trend[whichBar]==1) doAlert(whichBar,"BUY"); if(trend[whichBar]==-1) doAlert(whichBar,"SELL");}}}
//+------------------------------------------------------------------------------------------------------------------+
   void doAlert(int forBar,string doWhat){static string previousAlert="nothing";
   static datetime previousTime; string msg;
   if(previousAlert!=doWhat||previousTime!=Time[forBar]) {previousAlert=doWhat; previousTime=Time[forBar];
   msg=StringConcatenate(Symbol()," "," at ",TimeToStr(TimeLocal(),TIME_SECONDS),
   "\n"+timeFrameToString(Period())+" Chart Signal changed to ",doWhat+"\nWelcome to the World of Forex");
   if(alertsmsg) Alert(msg); if(alertsSound) PlaySound("alert2.wav"); 
   if(alertsNotify) SendNotification(StringConcatenate(""+msg));}}
//+------------------------------------------------------------------------------------------------------------------+
   string sTfTable[]= {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
   int    iTfTable[]= {1,5,15,30,60,240,1440,10080,43200};
//+------------------------------------------------------------------------------------------------------------------+
   string timeFrameToString(int tf) {for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
   if(tf==iTfTable[i]) return(sTfTable[i]); return("");}
//+------------------------------------------------------------------------------------------------------------------+

